
(* Written by Martin Kacer *)

Program MaxDistance;
Const MAX_VERT = 512;
Var TaskCnt, TaskNum : Integer;
	Dist			 : Array [1..MAX_VERT, 1..MAX_VERT] of Integer;
	NumVert, NumEdge : Integer;
	I, J, K			 : Integer;
	Len				 : Integer;
	Disconnect		 : Boolean;

Begin
	Readln (TaskCnt);
	For TaskNum:= 1 to TaskCnt do
	Begin
		ReadLn (NumVert, NumEdge);
		For I:= 1 to NumVert do
			For J:= 1 to NumVert do
				Dist[I,J]:= -1;

		For I:= 1 to NumEdge do Begin
			ReadLn (J, K, Len);
			Dist[J,K]:= Len;
			Dist[K,J]:= Len;
		End;

		For I:= 1 to NumVert do
			For J:= 1 to NumVert do If (Dist[J,I] >= 0) then
				For K:= 1 to NumVert do
					If (Dist[I,K] >= 0) then
						If (Dist[J,K] < 0)
								or (Dist[J,K] > Dist[J,I] + Dist[I,K]) then
							Dist[J,K]:= Dist[J,I] + Dist[I,K];

		Len:= -1;
		Disconnect:= false;
		For I:= 1 to NumVert do
			For J:= 1 to NumVert do
				If (Dist[I,J] < 0) then
					Disconnect:= true
				else
					If (I <> J) and (Len < Dist[I,J]) then
						Len:= Dist[I,J];

		if (Disconnect) then
			WriteLn ('Bez spojeni neni veleni!')
		else
			WriteLn ('Nejvetsi vzdalenost je ', Len, '.');
	End;
End.
