
/* Written by Jaroslav Volsicky */

#include <stdio.h>
#include <string.h>

#define MAX_VRCH	512
const int VZDAL_INIT=0x11111111;

int vzdal[MAX_VRCH][MAX_VRCH];

int h[MAX_VRCH];
int docas[MAX_VRCH];

int find_maxmin(int start,int vr)
{
	int i,j,spoj=1,hm,hmj,lp=vr;

	memset(h,VZDAL_INIT,sizeof(int)*MAX_VRCH);
	memset(docas,1,sizeof(int)*MAX_VRCH);

	h[start]=0;
	while (lp-->0 && spoj)
	{
		hm=VZDAL_INIT;
		hmj=-1;
		for (i=0;i<vr;i++)
			if (docas[i] && h[j=i]<VZDAL_INIT && hm>h[i])
				hm=h[hmj=i];
		if (hmj!=-1) j=hmj;

		if (h[j]==VZDAL_INIT) spoj=0;
		else
		{
			docas[j]=0;
			for (i=0;i<vr;i++)
				if (vzdal[j][i]<VZDAL_INIT && h[j]+vzdal[j][i]<h[i])
					h[i]=h[j]+vzdal[j][i];
		}
	}
	return spoj?h[j]:-1;
}

int main()
{
	int a,b;
	int start;
	int examples,hr,vr;
	int v1,v2,d;
	int result, presult;
	scanf("%d\n",&examples);
	for (a=0;a<examples;a++)
	{
		memset(vzdal,VZDAL_INIT,sizeof(int)*MAX_VRCH*MAX_VRCH);

		scanf("%d %d\n",&vr,&hr);
		for (b=0;b<hr;b++)
		{
			scanf("%d %d %d\n",&v1,&v2,&d);
			vzdal[v2-1][v1-1]=vzdal[v1-1][v2-1]=d;
		}
		presult=result=start=0;
		while (start<vr && presult>-1)
		{
			if ((presult=find_maxmin(start,vr)) > result)
				result=presult;
			start++;
		}
		if (presult>-1)
			printf("Nejvetsi vzdalenost je %d.\n",result);
		else
			printf("Bez spojeni neni veleni!\n");
	}
	return 0;
}
